import { OnInit, ElementRef, OnChanges, SimpleChanges, NgZone, EventEmitter, OnDestroy, Renderer2, KeyValueDiffers } from "@angular/core";
import * as codemirror from "codemirror";
export declare class CodeMirrorComponent implements OnInit, OnChanges, OnDestroy {
    private elementRef;
    private ngZone;
    private renderer;
    private _differs;
    private _codeWrapElement;
    private _codemirrorContentObserver;
    private _code;
    code: string;
    autoMaxHeight: number;
    options: codemirror.EditorConfiguration;
    delayRefreshTime: number;
    codeChange: EventEmitter<string>;
    focusChange: EventEmitter<boolean>;
    textAreaRef: ElementRef;
    codemirrorClassName: boolean;
    editor: codemirror.EditorFromTextArea;
    private _differ;
    constructor(elementRef: ElementRef, ngZone: NgZone, renderer: Renderer2, _differs: KeyValueDiffers);
    ngOnInit(): void;
    ngOnChanges(simpleChanges: SimpleChanges): void;
    initializeCodemirror(): void;
    initializeAutoMaxHeight(): void;
    private applyEditorHeight;
    setOptionIfChanged(optionName: string, newValue: any): void;
    ngOnDestroy(): void;
}
